<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>Order Detail</title>

    <link
      rel="stylesheet"
      href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css"
    />
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.16.0/umd/popper.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>

    <style>
      .for-label {
        padding: 0rem;
        text-align: end;
      }
    </style>
  </head>
  <body onload="onPageLoading()">
    <div class="container">
      <h3 class="text-center" style="margin: 2rem;">Order Detail!!!!</h3>
      <div class="row">
        <div class="col-md-6">
          <div class="row form-group">
            <div class="col-md-3 for-label">
              <label for="input-order-code">Order Code</label>
            </div>
            <div class="col-md-9">
              <input type="text" class="form-control" id="input-order-code" />
            </div>
          </div>

          <div class="row form-group">
            <div class="col-md-3 for-label">
              <label for="input-duong-kinh">Đường kính Pizza</label>
            </div>
            <div class="col-md-9">
              <input type="text" class="form-control" id="input-duong-kinh" />
            </div>
          </div>

          <div class="row form-group">
            <div class="col-md-3 for-label">
              <label for="select-drink">Đồ uống</label>
            </div>
            <div class="col-md-9">
              <!-- <select name="" id="select-drink" class="form-control">
                <option>Chọn đồ uống</option>
              </select> -->
              <input type="text" class="form-control" id="select-drink" />
            </div>
          </div>

          <div class="row form-group">
            <div class="col-md-3 for-label">
              <label for="input-voucher-id">Voucher ID</label>
            </div>
            <div class="col-md-9">
              <input type="text" class="form-control" id="input-voucher-id" />
            </div>
          </div>

          <div class="row form-group">
            <div class="col-md-3 for-label">
              <label for="input-salad">Salad</label>
            </div>
            <div class="col-md-9">
              <input type="text" class="form-control" id="input-salad" />
            </div>
          </div>

          <div class="row form-group">
            <div class="col-md-3 for-label">
              <label for="input-giam-gia">Giảm giá</label>
            </div>
            <div class="col-md-9">
              <input type="text" class="form-control" id="input-giam-gia" />
            </div>
          </div>

          <div class="row form-group">
            <div class="col-md-3 for-label">
              <label for="input-email">Email</label>
            </div>
            <div class="col-md-9">
              <input type="text" class="form-control" id="input-email" />
            </div>
          </div>

          <div class="row form-group">
            <div class="col-md-3 for-label">
              <label for="input-dia-chi">Địa chỉ</label>
            </div>
            <div class="col-md-9">
              <input type="text" class="form-control" id="input-dia-chi" />
            </div>
          </div>

          <div class="row form-group">
            <div class="col-md-3 for-label">
              <label for="select-trang-thai">Trạng thái đơn hàng</label>
            </div>
            <div class="col-md-9">
              <!-- <select name="" id="select-trang-thai" class="form-control">
                <option value="0">Trạng thái</option>
              </select> -->
              <input type="text" class="form-control" id="select-trang-thai" />
            </div>
          </div>

          <div class="row form-group">
            <div class="col-md-3 for-label">
              <label for="input-ngay-cap-nhat">Ngày cập nhật</label>
            </div>
            <div class="col-md-9">
              <input
                type="text"
                class="form-control"
                id="input-ngay-cap-nhat"
              />
            </div>
          </div>
        </div>
        <div class="col-md-6">
          <div class="row form-group">
            <div class="col-md-3 for-label">
              <label for="select-co-combo">Cỡ Combo</label>
            </div>
            <div class="col-md-9">
              <!-- <select name="" id="select-co-combo" class="form-control">
                <option>Chọn cỡ Combo (Combo size)</option>
              </select> -->
              <input type="text" class="form-control" id="select-co-combo" />
            </div>
          </div>

          <div class="row form-group">
            <div class="col-md-3 for-label">
              <label for="input-suon-nuong">Sườn nướng (miếng)</label>
            </div>
            <div class="col-md-9">
              <input type="text" class="form-control" id="input-suon-nuong" />
            </div>
          </div>

          <div class="row form-group">
            <div class="col-md-3 for-label">
              <label for="input-so-luong-nuoc">Số lượng nước uống</label>
            </div>
            <div class="col-md-9">
              <input
                type="text"
                class="form-control"
                id="input-so-luong-nuoc"
              />
            </div>
          </div>

          <div class="row form-group">
            <div class="col-md-3 for-label">
              <label for="select-loai-pizza">Loại Pizza</label>
            </div>
            <div class="col-md-9">
              <!-- <select name="" id="select-loai-pizza" class="form-control">
                <option>Chọn loại Pizza</option>
              </select> -->
              <input type="text" class="form-control" id="select-loai-pizza" />
            </div>
          </div>

          <div class="row form-group">
            <div class="col-md-3 for-label">
              <label for="input-thanh-tien">Thành tiền</label>
            </div>
            <div class="col-md-9">
              <input type="text" class="form-control" id="input-thanh-tien" />
            </div>
          </div>

          <div class="row form-group">
            <div class="col-md-3 for-label">
              <label for="input-ho-ten">Họ và tên</label>
            </div>
            <div class="col-md-9">
              <input type="text" class="form-control" id="input-ho-ten" />
            </div>
          </div>

          <div class="row form-group">
            <div class="col-md-3 for-label">
              <label for="input-so-dien-thoai">Số điện thoại</label>
            </div>
            <div class="col-md-9">
              <input
                type="text"
                class="form-control"
                id="input-so-dien-thoai"
              />
            </div>
          </div>

          <div class="row form-group">
            <div class="col-md-3 for-label">
              <label for="input-loi-nhan">Lời nhắn</label>
            </div>
            <div class="col-md-9">
              <input type="text" class="form-control" id="input-loi-nhan" />
            </div>
          </div>

          <div class="row form-group">
            <div class="col-md-3 for-label">
              <label for="input-ngay-tao">Ngày tạo đơn</label>
            </div>
            <div class="col-md-9">
              <input type="text" class="form-control" id="input-ngay-tao" />
            </div>
          </div>
        </div>
      </div>
      <div
        class="row"
        style="margin-bottom: 2rem; display: flex; justify-content: end;"
      >
        <button
          class="btn text-light bg-success"
          style="margin-right: 1rem;"
          onclick="onBtnConfirmClick()"
        >
          Confirm
        </button>
        <button class="btn text-light bg-info" onclick="onBtnCancelClick()">
          Cancel
        </button>
      </div>
    </div>
  </body>

  <script>
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    var gId = "";
    var gOrderCode = "";
    const vBASE_URL = "http://203.171.20.210:8080/devcamp-pizza365/orders";
    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */

    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    //hàm thực thi khi tải trang
    function onPageLoading() {
      var vQueryObj = {
        id: "",
        orderCode: "",
      };
      //B1: lấy dữ liệu từ trang web trước
      thuThapDuLieu(vQueryObj);

      //B2: kiểm tra dữ liệu
      var vCheck = kiemtraDuLieu(vQueryObj);
      if (vCheck) {
        //B3: gọi api
        var vXHTMLRequest = new XMLHttpRequest();
        goiApi(vXHTMLRequest, vQueryObj);
        vXHTMLRequest.onreadystatechange = function () {
          if (
            this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK &&
            this.status == gREQUEST_STATUS_OK
          ) {
            console.log(vXHTMLRequest.responseText);
            //B4: hiển thị dữ liệu
            var bOrderObj = JSON.parse(vXHTMLRequest.responseText);
            hienThiDuLieu(bOrderObj);
          }
        };
      } else {
        history.back();
      }
    }

    //hàm thực thi khi nút Confirm được ấn
    function onBtnConfirmClick() {
      console.log("Id của đơn hàng: " + gId);
      //gọi api để update trạng thái đơn hàng thành Confirmed
      var vXmlHttpUpdateOrder = new XMLHttpRequest();
      goiApiUpdate(vXmlHttpUpdateOrder, gId);

      vXmlHttpUpdateOrder.onreadystatechange = function () {
        if (
          this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK &&
          this.status == gREQUEST_STATUS_OK
        ) {
          var vUpdatedOrder = vXmlHttpUpdateOrder.responseText;
          console.log(vUpdatedOrder);
        }
      };
    }

    //hàm thực thi khi nút Cancel được ấn
    function onBtnCancelClick() {
      console.log("Id của đơn hàng (từ nút Cancel): " + gId);

      //gọi api để update trạng thái đơn hàng thành Cancel
      var vXmlHttpUpdateOrderC = new XMLHttpRequest();
      goiApiUpdateC(vXmlHttpUpdateOrderC, gId);

      vXmlHttpUpdateOrderC.onreadystatechange = function () {
        if (
          this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK &&
          this.status == gREQUEST_STATUS_OK
        ) {
          var vUpdatedOrderC = vXmlHttpUpdateOrderC.responseText;
          console.log(vUpdatedOrderC);
        }
      };
    }
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    //hàm thu thập dữ liệu
    function thuThapDuLieu(paramQueryObj) {
      var vUrlString = window.location.href; //đường đẫn gọi đến trang

      //tạo đối tượng url để truy vấn tham số
      var vUrlObject = new URL(vUrlString);
      //get a parameter
      gId = vUrlObject.searchParams.get("id");
      gOrderCode = vUrlObject.searchParams.get("orderCode");

      paramQueryObj.id = gId;
      paramQueryObj.orderCode = gOrderCode;

      console.log(paramQueryObj);
    }

    //hàm kiểm tra dữ liệu
    function kiemtraDuLieu(paramQueryObj) {
      if (paramQueryObj.id == null) {
        alert("Lỗi id");
        return false;
      }

      if (paramQueryObj.orderCode == null) {
        alert("Lỗi order code");
        return false;
      }

      return true;
    }

    //hàm gọi api get order by order code
    function goiApi(paramXHTMLRequest, paramQueryObj) {
      paramXHTMLRequest.open(
        "GET",
        vBASE_URL + "/" + paramQueryObj.orderCode,
        true
      );
      paramXHTMLRequest.send();
    }

    //hàm hiển thị dữ liệu order lên các trường trên form
    function hienThiDuLieu(paramOrderObj) {
      var vOrderCodeInput = document.getElementById("input-order-code");
      var vDuongKinhInput = document.getElementById("input-duong-kinh");
      var vDrinkSelect = document.getElementById("select-drink");
      var vVoucherIdInput = document.getElementById("input-voucher-id");
      var vSaladInput = document.getElementById("input-salad");
      var vGiamGiaInput = document.getElementById("input-giam-gia");
      var vEmailInput = document.getElementById("input-email");
      var vDiaChiInput = document.getElementById("input-dia-chi");
      var vTrangThaiSelect = document.getElementById("select-trang-thai");
      var vNgayCapNhatInput = document.getElementById("input-ngay-cap-nhat");
      var vCoComboSelect = document.getElementById("select-co-combo");
      var vSuonNuongInput = document.getElementById("input-suon-nuong");
      var vSLNuocInput = document.getElementById("input-so-luong-nuoc");
      var vLoaiPizzaSelect = document.getElementById("select-loai-pizza");
      var vThanhTienInput = document.getElementById("input-thanh-tien");
      var vHoTenInput = document.getElementById("input-ho-ten");
      var vSDTInput = document.getElementById("input-so-dien-thoai");
      var vLoiNhanInput = document.getElementById("input-loi-nhan");
      var vNgayTaoInput = document.getElementById("input-ngay-tao");

      vOrderCodeInput.value = paramOrderObj.orderCode;
      vDuongKinhInput.value = paramOrderObj.duongKinh;
      vDrinkSelect.value = paramOrderObj.idLoaiNuocUong;
      vVoucherIdInput.value = paramOrderObj.idVourcher;
      vSaladInput.value = paramOrderObj.salad;
      vGiamGiaInput.value = paramOrderObj.giamGia;
      vEmailInput.value = paramOrderObj.email;
      vDiaChiInput.value = paramOrderObj.diaChi;
      vTrangThaiSelect.value = paramOrderObj.trangThai;
      vNgayCapNhatInput.value = paramOrderObj.ngayCapNhat;
      vCoComboSelect.value = paramOrderObj.kichCo;
      vSuonNuongInput.value = paramOrderObj.suon;
      vSLNuocInput.value = paramOrderObj.soLuongNuoc;
      vLoaiPizzaSelect.value = paramOrderObj.loaiPizza;
      vThanhTienInput.value = paramOrderObj.thanhTien;
      vHoTenInput.value = paramOrderObj.hoTen;
      vSDTInput.value = paramOrderObj.soDienThoai;
      vLoiNhanInput.value = paramOrderObj.loiNhan;
      vNgayTaoInput.value = paramOrderObj.ngayTao;
    }

    //hàm gọi api để update trạng thái đơn hàng thành confirmed
    function goiApiUpdate(paramXmlHttpUpdateOrder, paramId) {
      var vObjectRequest = {
        trangThai: "confirmed", //3 trạng thái: open, confirmed, cancel
      };

      paramXmlHttpUpdateOrder.open("PUT", vBASE_URL + "/" + paramId);
      paramXmlHttpUpdateOrder.setRequestHeader(
        "Content-Type",
        "application/json;charset=UTF-8"
      );
      paramXmlHttpUpdateOrder.send(JSON.stringify(vObjectRequest));
    }

    //hàm gọi api để update trạng thái đơn hàng thành cancel
    function goiApiUpdateC(paramXmlHttpUpdateOrder, paramId) {
      var vObjectRequest = {
        trangThai: "cancel", //3 trạng thái: open, confirmed, cancel
      };

      paramXmlHttpUpdateOrder.open("PUT", vBASE_URL + "/" + paramId);
      paramXmlHttpUpdateOrder.setRequestHeader(
        "Content-Type",
        "application/json;charset=UTF-8"
      );
      paramXmlHttpUpdateOrder.send(JSON.stringify(vObjectRequest));
    }
  </script>
</html>
